    
''
' Mike Trader - Jan 2008  
'
'  From Decimal Floating-Point
'  To 32-bit and 64-bit Hexadecimal Representations
'  Along with Their Binary Equivalents  
'  Based on Java from: http://www.rit.edu/~meseec/eecc250-winter99/IEEE-754.html
''     
             

#COMPILE EXE 
#DIM ALL
     
GLOBAL hDbg AS LONG             
                


TYPE ieeeTYPE '
    fSize             AS LONG             ' Size 32/64 bits                                               
    BinaryPower       AS LONG             ' 0                                                  
    DecValue          AS STRING * 256     ' ""                                                 
    DispStr           AS STRING * 256     ' ""  
                      
    Dec2Bin           AS STRING * 256     ' Dec2Bin        ' convert dec. to bin.          
    StatCond          AS STRING * 256     ' "NORMAL"                                           
    StatCond64        AS STRING * 256     ' "NORMAL"                                           
    BinString         AS STRING * 256     ' ""  
                       
    BinVal(1 TO 2102) AS BYTE             ' NEW ARRAY(2102)

    ExpBias           AS LONG             ' 127            
    MaxExp            AS LONG             ' 127            
    MinExp            AS LONG             ' -126           
    MinUnnormExp      AS LONG             ' -149           
    Result(1 TO 64)   AS BYTE             ' NEW ARRAY(32) / NEW ARRAY(64)  
                                          
END TYPE 

 

TYPE DisplayTYPE ' UDT of Input/Output strings                                           
    InputDec      AS STRING * 256 ' User Input                                           
                                                                                         
    stat32        AS STRING * 256 '  dec64sig                                                    
    dec32         AS STRING * 256 '                                                                  
    hex32         AS STRING * 256 '                                                      
    bin32_0       AS STRING * 256 '                                                      
    bin32_1       AS STRING * 256 '                                                      
    bin32_9       AS STRING * 256 '                                                      
                                                                                         
    stat64        AS STRING * 256 '                                                      
    dec64         AS STRING * 256 '                                                      
    hex64         AS STRING * 256 '                                                                  
    bin64_0       AS STRING * 256 '                                                            
    bin64_1       AS STRING * 256 '                                                                  
    bin64_12      AS STRING * 256 '                                                      
                                                                                         
    binpwr32      AS LONG '                                                      
    binpwr32f     AS LONG '                                                      
    dec32sig      AS STRING * 256 ' 

    binpwr64      AS LONG '                                                      
    binpwr64f     AS LONG '                                                      
    dec64sig      AS STRING * 256 '                                                   
                
    Entered       AS DOUBLE       ' User Input
                             
END TYPE
        
MACRO LN10  = 2.30258509299404568402    

MACRO LN2	  = 0.693147180559945309

MACRO SQRT2	= 0.707106781186547524

         
''  
FUNCTION CharAt( SVar AS STRING, sPos AS LONG ) AS STRING 

  FUNCTION = MID$(sVar, sPos, 1) ' Convert to MID$

END FUNCTION 
       

''  
FUNCTION Substring( SVar AS STRING, sPos AS LONG, ePos AS LONG ) AS STRING 

  FUNCTION = MID$(sVar, sPos, ePos-sPos) ' Convert to MID$

END FUNCTION 

                                                                                                    
''  
FUNCTION FORMATieeeTYPE( ie AS ieeeTYPE ) AS STRING                                                    
                      
  LOCAL i AS LONG                                                                              
  LOCAL sRes AS STRING                                                                              
                                                                                                    
    sRes = sRes + "Size=        "  + $TAB + STR$ (ie.fSize       ) + $CRLF     ' LONG                                                             
    sRes = sRes + "BinaryPower= "  + $TAB + STR$ (ie.BinaryPower ) + $CRLF     ' LONG                                                             
    sRes = sRes + "DecValue=    "  + $TAB + TRIM$(ie.DecValue    ) + $CRLF     ' STRING                                                            
    sRes = sRes + "DispStr=     "  + $TAB + TRIM$(ie.DispStr     ) + $CRLF     ' STRING  
    sRes = sRes + "StatCond=    "  + $TAB + TRIM$(ie.StatCond    ) + $CRLF     ' STRING
    sRes = sRes + "StatCond64=  "  + $TAB + TRIM$(ie.StatCond64  ) + $CRLF     ' STRING
    sRes = sRes + "BinString=   "  + $TAB + TRIM$(ie.BinString   ) + $CRLF     ' STRING
    sRes = sRes + "ExpBias=     "  + $TAB + STR$ (ie.ExpBias     ) + $CRLF     ' LONG      
    sRes = sRes + "MaxExp=      "  + $TAB + STR$ (ie.MaxExp      ) + $CRLF     ' LONG  
    sRes = sRes + "MinExp=      "  + $TAB + STR$ (ie.MinExp      ) + $CRLF     ' LONG                                                                 
    sRes = sRes + "MinUnnormExp="  + $TAB + STR$ (ie.MinUnnormExp) + $CRLF     ' LONG  
                                                           
      
'    sRes = sRes + "BinVal=      "  + $TAB     
'    FOR i = 1 TO 2102  
'      IF ie.BinVal(i) THEN
'        sRes = sRes + "1"     ' BYTE
'      ELSE
'        sRes = sRes + "0"      ' BYTE
'      END IF
'    NEXT  
'    sRes = sRes + $CRLF           
          
    sRes = sRes + "Result=      " + $TAB
    FOR i = 1 TO 64 
      IF ie.Result(i) THEN
        sRes = sRes + "1"      ' BYTE
      ELSE
        sRes = sRes + "0"     ' BYTE
      END IF
    NEXT 
    sRes = sRes + $CRLF
                             
  FUNCTION = sRes                                      
                                                       
END FUNCTION                                         
                                                     
                                                                                                    
''  
FUNCTION FORMATDisplayTYPE( Obj AS DisplayTYPE ) AS STRING                                                    
                                                                                                    
  LOCAL sRes AS STRING                                                                              
                                                                                                    
    sRes = sRes + "InputDec="  + TRIM$(Obj.InputDec ) + $CRLF                                                                
    sRes = sRes + "stat32="    + TRIM$(Obj.stat32   ) + $CRLF                                                                
    sRes = sRes + "dec32="     + TRIM$(Obj.dec32    ) + $CRLF                                                                
    sRes = sRes + "hex32="     + TRIM$(Obj.hex32    ) + $CRLF                                                                
    sRes = sRes + "bin32_0="   + TRIM$(Obj.bin32_0  ) + $CRLF                                                                
    sRes = sRes + "bin32_1="   + TRIM$(Obj.bin32_1  ) + $CRLF                                                                
    sRes = sRes + "bin32_9="   + TRIM$(Obj.bin32_9  ) + $CRLF                                                                
    sRes = sRes + "stat64="    + TRIM$(Obj.stat64   ) + $CRLF                                                                
    sRes = sRes + "dec64="     + TRIM$(Obj.dec64    ) + $CRLF
    sRes = sRes + "hex64="     + TRIM$(Obj.hex64    ) + $CRLF
    sRes = sRes + "bin64_0="   + TRIM$(Obj.bin64_0  ) + $CRLF
    sRes = sRes + "bin64_1="   + TRIM$(Obj.bin64_1  ) + $CRLF
    sRes = sRes + "bin64_12="  + TRIM$(Obj.bin64_12 ) + $CRLF

    sRes = sRes + "binpwr32="  + STR$ (Obj.binpwr32 ) + $CRLF
    sRes = sRes + "binpwr32f=" + STR$ (Obj.binpwr32f) + $CRLF                                                                
    sRes = sRes + "dec32sig="  + TRIM$(Obj.dec32sig ) + $CRLF  

    sRes = sRes + "binpwr64="  + STR$ (Obj.binpwr64 ) + $CRLF
    sRes = sRes + "binpwr64f=" + STR$ (Obj.binpwr64f) + $CRLF                                                                
    sRes = sRes + "dec64sig="  + TRIM$(Obj.dec64sig ) + $CRLF 
 
    sRes = sRes + "entered="   + STR$ (Obj.entered  ) + $CRLF                                                               
     
  FUNCTION = sRes

END FUNCTION  
               
          
               

''
SUB Initieee( FloatSize AS LONG, this AS ieeeTYPE )  ' object construction function
                       

    this.fSize        = FloatSize            ' 
    this.BinaryPower  = 0                    ' 
    this.DecValue     = ""                   ' 
    this.DispStr      = ""                   ' 
    this.StatCond     = "NORMAL"             ' Default
    this.StatCond64   = "NORMAL"             ' Default

    this.BinVal(1)    = 0 ' NEW ARRAY(2102) - 1 (carry bit) + 1023 + 1 + 1022 + 53 + 2 (round bits)

    IF FloatSize = 32 THEN
      this.ExpBias      =  127
      this.MaxExp       =  127
      this.MinExp       = -126
      this.MinUnnormExp = -149
      this.Result(1)    = 0     ' NEW ARRAY(32)

    ELSEIF FloatSize = 64 THEN
      this.ExpBias      =  1023
      this.MaxExp       =  1023
      this.MinExp       = -1022
      this.MinUnnormExp = -1074
      this.Result(1)    = 0     ' NEW ARRAY(64)

    END IF  

END SUB
   


''
FUNCTION Canonical( sNumINPUT AS STRING ) AS STRING
         

  LOCAL locE, ePos, expnum, locDPact, locDP, sPos, MSDfound, ix, expdelta AS LONG ' ?
  LOCAL expstart, expprecision AS LONG ' ?    
  LOCAL sOut, sNumerals, sExp, sSign, sExpsign, sExpstrtmp AS STRING
                                  

    sNumerals     = "0123456789"
  
    expprecision  = 5
  
    sNumINPUT     = UCASE$(sNumINPUT) ' PRINT #hDbg, "sNumINPUT=" + sNumINPUT 
                       

    locE = INSTR(sNumINPUT, "E")
    IF locE THEN ' found 
      ePos   = locE
      sExp   = Substring(sNumINPUT, locE, LEN(sNumINPUT))
      expnum = VAL(sExp)
    ELSE
      ePos   = LEN(sNumINPUT)  
      expnum = 0  
    END IF ' 
              

    locDPact = INSTR(sNumINPUT, ".")
    IF locDPact THEN
      locDP = locDPact
    ELSE
      locDP = ePos 
    END IF
       

    sPos = 1
    IF     CharAt(sNumINPUT, sPos) = "-" THEN
      INCR sPos
      sSign = "-"
    ELSEIF CharAt(sNumINPUT, sPos) = "+" THEN
      INCR sPos
      sSign = "+"
    ELSE
      sSign = "+" 
    END IF ' PRINT #hDbg, "sSign=" + sSign  

  
    MSDfound = 0 ' false
    WHILE sPos <= ePos AND MSDfound = 0 ' Check for anything other than numbers at start of string 
      ix = 1
      WHILE ix <= LEN(sNumerals)  
        IF CharAt(sNumINPUT, sPos) = CharAt(sNumerals, ix) THEN   
          MSDfound = 1 ' true PRINT #hDbg, "MSDfound sPos=" + STR$(sPos)
          EXIT LOOP
        END if
        INCR ix
      WEND 
      INCR sPos
    WEND
    DECR sPos ' counter last INCR
              
    IF MSDfound THEN ' Most Sig Digit
      expdelta = locDP - sPos ' PRINT #hDbg, "expdelta=" + STR$(expdelta)
      IF expdelta > 0 THEN expdelta = expdelta - 1 
      expnum = expnum + expdelta
    ELSE   ' No significant digits found, value is zero
      expnum = 0 
    END IF

    expstart = 1 
    sExpstrtmp = STR$(expnum)
    INCR expstart
    IF expnum < 0 THEN
      sExpsign = "-"
    ELSE
      sExpsign = "+"  
    END IF

    sExp = "E" + sExpsign ' 

    ix = 0
    WHILE ix < (expprecision - LEN(sExpstrtmp) + expstart)
      sExp = sExp + "0"
      INCR ix
    WEND
    sExp = sExp + Substring(sExpstrtmp, expstart, LEN(sExpstrtmp)+1) ' PRINT #hDbg, "sExp=" + sExp
  
    sOut = sSign ' PRINT #hDbg, "0 sOut=" + sOut 
  
    IF locDPact = sPos+1 THEN ' 
      sOut = sOut + Substring(sNumINPUT, sPos, ePos+1) ' PRINT #hDbg, "1 sOut=" + sOut 

    ELSEIF ePos = sPos+1 THEN
      sOut = sOut + Substring(sNumINPUT, sPos, ePos+1) ' 
      sOut = sOut + "." ' PRINT #hDbg, "2 sOut=" + sOut 

    ELSEIF locDPact < sPos THEN
      sOut = sOut + Substring(sNumINPUT, sPos, sPos+1)
      sOut = sOut + "." '
      sOut = sOut + Substring(sNumINPUT, sPos+1, ePos+1) ' PRINT #hDbg, "3 sOut=" + sOut 

    ELSEIF locDPact THEN
      sOut = sOut + Substring(sNumINPUT, sPos, sPos+1) ' PRINT #hDbg, "4 sPos=" + STR$(sPos)
      sOut = sOut + "." ' PRINT #hDbg, "4 sOut=" + sOut 
      sOut = sOut + Substring(sNumINPUT, sPos+1, locDPact) ' PRINT #hDbg, "4 sOut=" + sOut 
      sOut = sOut + Substring(sNumINPUT, locDPact+1, ePos+1) ' PRINT #hDbg, "4 sOut=" + sOut 

    ELSE
      sOut = sOut + Substring(sNumINPUT, sPos, ePos)
      sOut = sOut + "." ' PRINT #hDbg, "5 sOut=" + sOut
    END IF
  
    sOut = sOut + sExp ' PRINT #hDbg, "sOut=" + sOut

  FUNCTION = sOut

END FUNCTION
         
            
     
''
FUNCTION A_gt_B( sA AS STRING, sB AS STRING ) AS LONG
           
  LOCAL greater, ePos, ix, Adigit, Bdigit AS LONG ' ? 
  LOCAL sOut, sNumerals AS STRING


    sNumerals = "0123456789"
  
    greater = 0
  
    IF LEN(sA) > LEN(sB) THEN
      ePos = LEN(sA)
    ELSE
      ePos = LEN(sB)  
    END IF
  
    ix = 0
    WHILE ix < ePos
      IF ix <= LEN(sA) THEN
        Adigit = INSTR( sNumerals, CharAt(sA, ix) )
      ELSE
        Adigit = 0 
      END IF
  
      IF ix <= LEN(sB) THEN
        Bdigit = INSTR( sNumerals, CharAt(sB, ix) )
      ELSE
        Bdigit = 0  
      END IF
  
      IF Adigit < Bdigit THEN
        EXIT LOOP 
        greater = 0
      ELSEIF Adigit > Bdigit THEN
        greater = 1
        EXIT LOOP
      END IF
  
      INCR ix
    WEND ' end while

  FUNCTION = greater

END FUNCTION
                          

''
FUNCTION MostSigOrder( sNumINPUT AS STRING ) AS STRING
  
  LOCAL expprecision, expbias, ePos, expnum, ix AS LONG ' ?    
  LOCAL sOut, sExp AS STRING

    expprecision  = 5 ' PRINT #hDbg, "sNumINPUT=" + sNumINPUT 
    expbias       = 50000
    ePos          = INSTR(sNumINPUT, "E")
    sOut          = Substring(sNumINPUT, ePos+1, LEN(sNumINPUT)+1) ' PRINT #hDbg, "sOut=" + sOut 
    expnum        = VAL(sOut)
    expnum        = expnum + expbias
    sExp          = FORMAT$( expnum )
    sOut          = sExp
  
    ix = 0
    WHILE ix < expprecision - LEN(sExp)
      sOut = "0" + sOut
      INCR ix
    WEND ' PRINT #hDbg, "sOut=" + sOut
  
    sOut = sOut + Substring(sNumINPUT, 2, 3) ' PRINT #hDbg, "sOut=" + sOut
    sOut = sOut + Substring(sNumINPUT, 4, ePos) ' PRINT #hDbg, "sOut=" + sOut

  FUNCTION = sOut

END FUNCTION
  

''
FUNCTION OvfCheck( sNumINPUT AS STRING ) AS STRING
          
  LOCAL sOut AS STRING

    IF A_gt_B( MostSigOrder(sNumINPUT), "5030817976931348623157" ) THEN ' magnitude > +1.7976931348623157E+00308
      sOut = "INFINITY"
      IF CharAt( sNumINPUT, 1 ) = "-" THEN sOut = "-" + sOut
    ELSE ' PRINT #hDbg, "A_gt_B=0" 
      sOut = sNumINPUT 
    END IF

  FUNCTION = sOut

END FUNCTION

     
''
FUNCTION UndfCheck( sNumINPUT AS STRING ) AS STRING
        
  LOCAL sOut AS STRING

    IF A_gt_B( "4967624703282292062328", MostSigOrder(sNumINPUT) ) THEN  ' magnitude < +2.4703282292062328E-00324
      FUNCTION = "UNDERFLOW" ' "UNDERFLOW"
    ELSE
      FUNCTION = "NORMAL"
    END IF

END FUNCTION
           
          

''
FUNCTION Dec2Bin( this AS ieeeTYPE, BYVAL sNumINPUT AS STRING ) AS STRING

  LOCAL binexpnt, intpart, index1, Cnst, Bias AS LONG ' ?  
  LOCAL value, NumINPUT, decpart AS DOUBLE  
  LOCAL sOut AS STRING  

  
    Cnst = 2102	' 1 (carry bit) + 1023 + 1 + 1022 + 53 + 2 (round bits)
    Bias = 1024
  
    FOR index1 = 0 TO Cnst ' Zero the array 
      this.BinVal(index1) = 0
    NEXT

    sNumINPUT = Canonical(sNumINPUT) ' PRINT #hDbg, "sNumINPUT="+sNumINPUT  


     ' sign bit
    IF CharAt(sNumINPUT, 1) = "-" THEN
      this.Result(0) = 1
    ELSE
      this.Result(0) = 0 
    END IF


     ' if value magnitude greater than 1.7976931348623157E+308, set infinity
    sNumINPUT = OvfCheck(sNumINPUT) ' PRINT #hDbg, "sNumINPUT="+sNumINPUT  
    IF INSTR(sNumINPUT, "INFINITY") THEN ' greater than 1.7976931348623157E+308
      binexpnt          = this.MaxExp + 1
      this.StatCond64   = "OVERFLOW"
      this.DispStr      = sNumINPUT 
      this.BinaryPower  = binexpnt ' output exponent value 
      EXIT FUNCTION                        
    END IF
                

     ' if value magnitude less than 2.4703282292062328E-324, set "UNDERFLOW".
    this.StatCond64 = UndfCheck(sNumINPUT) ' PRINT #hDbg, "sNumINPUT="+sNumINPUT 
    IF INSTR(this.StatCond64, "UNDERFLOW") THEN ' magnitude > 2.4703282292062328E-324
      binexpnt          = this.MinExp - 1     
      this.BinaryPower  = binexpnt ' output exponent value 
      EXIT FUNCTION                        
    END IF

    NumINPUT = VAL(sNumINPUT) ' convert 'input' from string to numeric    

     ' convert and seperate input to integer and decimal parts
    value   = ABS(NumINPUT)
    intpart = FIX(value)
    decpart = value - intpart ' PRINT #hDbg, "intpart="+STR$(intpart) + ", decpart="+STR$(decpart)   


     ' convert decimal part to binary 
    index1 = Bias + 1
    WHILE decpart > 0 AND index1 < Cnst
      decpart = decpart * 2 ' PRINT #hDbg, "" : PRINT #hDbg, "decpart="+STR$(decpart) 
      IF decpart >= 1 THEN ' PRINT #hDbg, "decpart=1"
        this.BinVal(index1) = 1 
        DECR decpart
      ELSE ' PRINT #hDbg, "decpart=0"
        this.BinVal(index1) = 0 
      END IF ' PRINT #hDbg, "BinVal="+STR$(this.BinVal(index1)) 
      sOut = sOut + STR$(this.BinVal(index1)) 
      INCR index1
    WEND         
          

     ' convert integer part to binary      
    index1 = Bias			
    WHILE index1 > 0
      this.BinVal(index1) = intpart MOD 2 ' PRINT #hDbg, "intpart="+STR$(intpart MOD 2) 
      sOut = sOut + STR$(this.BinVal(index1)) 
      IF intpart MOD 2 = 0 THEN
        intpart = intpart/2 
      ELSE ' PRINT #hDbg, "intpart/2="+STR$(intpart/2) 
        intpart = INT(intpart/2 - 0.5) ' 
      END IF ' PRINT #hDbg, "new intpart="+STR$(intpart)
      IF intpart = 0 THEN EXIT LOOP
      DECR index1 
    WEND ' PRINT #hDbg, FORMATieeeTYPE(this) 


     
    index1 = 1
    WHILE index1 < Cnst ' find most significant bit of significand
      INCR index1  
      IF this.BinVal(index1) THEN EXIT LOOP     
    WEND
    binexpnt = Bias - index1 ' obtain Binary exponent value PRINT #hDbg, "BINARY expnt="+STR$(binexpnt) 
                                

     ' support for zero and unnormalized numbers
    IF binexpnt < this.MinExp THEN binexpnt = this.MinExp - 1 ' exponent underflow for this precision
    this.BinaryPower = binexpnt ' output exponent value
             
  FUNCTION = sOut

END FUNCTION
         

''
FUNCTION Convert2Bin( this AS ieeeTYPE, rounding AS LONG ) AS STRING
 
          
  LOCAL binexpnt, index1, index2, Cnst, Bias, lastbit, rounded, index3, binexpnt2 AS LONG
  LOCAL moreBits AS LONG
                             
  LOCAL sOut AS STRING

    Cnst = 2102		 '  1 (carry bit) + 1023 + 1 + 1022 + 53 + 2 (round bits)
    Bias = 1024
  
     ' init      
    FOR index1 = 0 TO this.fSize ' Zero the array 
      this.Result(index1) = 0
    NEXT
					
'     this.Result(0) = signBit  ' sign bit

      IF this.fSize = 32 THEN index2 = 9 ELSE index2 = 12
  
      IF rounding AND this.StatCond64 = "NORMAL" THEN 

        
        index1 = 1
        WHILE index1 < Cnst ' find most significant bit of significand
          INCR index1  
          IF this.BinVal(index1) THEN EXIT LOOP     
        WEND
        binexpnt = Bias - index1 ' obtain Binary exponent value
                                    
        IF binexpnt >= this.MinExp THEN ' regular normalized numbers                                                      
          INCR index1	                  ' the value is shifted until the most significant 1 is to the left of the binary  
                                        ' point and that bit is implicit in the encoding if normalized numbers            
                                        ' support for zero and unnormalized numbers exponent underflow for this precision 
        ELSE ' zero or unnormalized
          binexpnt = this.MinExp - 1
          index1 = Bias - binexpnt
        END IF        

  
         ' use round to nearest value mode
         ' compute least significant (low-order) bit of significand
        lastbit = this.fSize - 1 - index2 + index1
  
         ' the bits folllowing the low-order bit have a value of (at least) 1/2
        IF (this.BinVal(lastbit + 1) = 1) THEN
          rounded = 0 ' odd low-order bit
          IF this.BinVal(lastbit) = 1 THEN
                        ' exactly 1/2 the way between odd and even rounds up to the even,
                        ' so the rest of the bits don't need to be checked to see if the value
                        ' is more than 1/2 since the round up to the even number will occur
            rounded = 1 ' anyway due to the 1/2
                        ' if odd low-order bit
          ELSE ' even low-order bit this.BinVal[lastbit] = 0
                        ' exactly 1/2 the way between even and odd rounds down to the even,
                        ' so the rest of the bits need to be checked to see if the value
                        ' is more than 1/2 in order to round up to the odd number
            index3 = lastbit + 2
            WHILE rounded = 0 AND index3 < Cnst
              rounded = this.BinVal(index3)
              INCR index3
            WEND ' while checking for more than 1/2
  
          END IF ' if even low-order bit (else section)
  
           ' do rounding "additions"
          index3 = lastbit
          WHILE rounded = 1 AND index3 >= 0

             '  0 + 1 -> 1 result with 0 carry
            IF this.BinVal(index3) = 0 THEN  ' if bit is a 0
              this.BinVal(index3) = 1 '  1 result
              rounded = 0 '  0 carry
             '  1 + 1 -> 0 result with 1 carry
            ELSE   ' this.BinVal[index3] = 1
              this.BinVal(index3) = 0 '  0 result  '  1 carry ' rounded = 1
            END IF ' if bit is a 1 (else section)
  
            DECR index3
          WEND ' while "adding" carries from right to left in bits
  
        END IF ' if at least 1/2
  
         ' obtain Binary exponent value
        index1 = index1 - 2
        IF index1 < 0 THEN index1 = 0
  
      END IF ' if rounding
           


            


      index1 = 1
      WHILE index1 < Cnst ' find most significant bit of significand
        INCR index1  
        IF this.BinVal(index1) THEN EXIT LOOP     
      WEND
      binexpnt2 = Bias - index1 ' obtain Binary exponent value
  
      IF this.StatCond64 = "NORMAL" THEN ' PRINT #hDbg, "StatCond64 = NORMAL" 
        binexpnt = binexpnt2
  
         ' regular normalized numbers
        IF binexpnt >= this.MinExp AND binexpnt <= this.MaxExp THEN ' if normalized numbers
                                   ' the value is shifted until the most
          INCR index1              ' significant 1 is to the left of the binary
                                   ' point and that bit is implicit in the encoding

         ' support for zero and unnormalized numbers
         ' exponent underflow for this precision
        ELSEIF binexpnt < this.MinExp THEN
          IF binexpnt2 = Bias - Cnst THEN
            this.StatCond = "NORMAL" ' value is truely zero
          ELSEIF binexpnt2 < this.MinUnnormExp THEN
            this.StatCond = "UNDERFLOW"
          ELSE
            this.StatCond = "UNNORMALIZED"
          END IF
          binexpnt = this.MinExp - 1
          index1 = Bias - binexpnt  

        END IF ' if zero or unnormalized (ELSEIF section) PRINT #hDbg, "StatCond="+TRIM$(this.StatCond) 

  
      ELSE  ' already special values
        binexpnt = this.BinaryPower
        index1   = Bias - binexpnt
        IF binexpnt > this.MaxExp THEN
          binexpnt = this.MaxExp + 1
        ELSEIF binexpnt < this.MinExp THEN
          binexpnt = this.MinExp - 1
        END IF  ' PRINT #hDbg, "binexpnt="+STR$(binexpnt)  

      END IF ' if already special (else section)
               

       ' copy the result Shift -> the binary string
      WHILE index2 < this.fSize AND index1 < Cnst
        this.Result(index2) = this.BinVal(index1)
        INCR index2
        INCR index1
      WEND ' while
  
       ' max exponent for this precision
      IF binexpnt > this.MaxExp OR this.StatCond64 <> "NORMAL" THEN 

         ' overflow of this precision, set infinity
        IF this.StatCond64 = "NORMAL" THEN ' if overflowed
          binexpnt      = this.MaxExp + 1
          this.StatCond = "OVERFLOW"
          this.DispStr  = "INFINITY"
  
          IF this.Result(0) = 1 THEN this.DispStr = "-" + this.DispStr
  
          IF this.fSize = 32 THEN 
            index2 = 9       
          ELSE 
            index2 = 12 
          END IF
  
           ' zero the significand
          WHILE index2 < this.fSize
            this.Result(index2) = 0
            INCR index2
          WEND ' while
  
        ELSE  ' already special values
          ' this.StatCond = ieee.statstring
          ' this.DispStr  = ieee.DispStr
        END IF ' if already special (else section)
                      
      END IF ' if max exponent
                 

       ' convert exponent value to binary representation
      IF this.fSize = 32 THEN 
        index1 = 8
      ELSE 
        index1 = 11 
      END IF

      this.BinaryPower = binexpnt
      binexpnt = binexpnt + this.ExpBias		 ' Bias
      WHILE binexpnt / 2 <> 0
        this.Result(index1) = binexpnt MOD 2  'PRINT #hDbg, "index1="+STR$(index1) + ", binexpnt="+STR$(binexpnt MOD 2) 
        IF binexpnt MOD 2 = 0 THEN 
          binexpnt = binexpnt / 2
        ELSE 
          binexpnt = binexpnt / 2 - 0.5 
        END IF
        index1 = index1 - 1
      WEND
  
       ' output binary result
      sOut = ""
      FOR index1 = 0 TO this.fSize-1 
        IF this.Result(index1) THEN
          sOut = sOut + "1"
        ELSE
          sOut = sOut + "0"
        END IF
      NEXT
 
  FUNCTION = sOut
  

END FUNCTION
                      




''
FUNCTION Convert2Hex( this AS ieeeTYPE ) AS STRING
                    
  
  LOCAL Valu, ix, i AS LONG ' ?
  LOCAL sOut, sNumerals AS STRING
                    

    sNumerals = "0123456789ABCDEF"

       ' convert binary result to hex
      FOR ix = 1 TO this.fSize STEP 4
        Valu = 0 ' PRINT #hDbg, "ix="+STR$(ix)
        FOR i = 0 TO 3 
          Valu = Valu + 2^(3-i) * this.Result(ix+i) ' PRINT #hDbg, "i="+STR$(i) + ", ix+i="+STR$(ix+i)+ ", Result(ix+i)="+STR$(this.Result(ix+i)) + ", 2^(3-i)="+STR$(2^(3-i)) + ", Valu="+STR$(Valu) 
        NEXT
        sOut = sOut + MID$(sNumerals, Valu+1, 1) ' PRINT #hDbg, "ix="+STR$(ix) + ", Valu="+STR$(Valu)
      NEXT ' PRINT #hDbg, "sOut="+sOut

  FUNCTION = sOut 

END FUNCTION
         

''
FUNCTION numStrClipOff( sNumINPUT AS STRING, precision AS LONG ) AS STRING
    
  
  LOCAL locE, ePos, count, ix, index2 AS LONG ' ?       
  LOCAL sOut, sResult, sNumerals AS STRING


    sNumerals = "0123456789"
  
    locE = INSTR(sNumINPUT,"e")
    IF locE THEN
      ePos = locE
    ELSE
      locE = INSTR(sNumINPUT,"E")
      IF locE THEN
        ePos = locE
      ELSE
        ePos = LEN(sNumINPUT)  
      END IF
    END IF
  
    count = 0
    ix = 1
    WHILE count < precision AND ix <= ePos
      IF INSTR(sNumerals, MID$(sNumINPUT,ix,1) ) THEN  count = count + 1
      INCR ix
    WEND
    sResult = substring(sNumINPUT, 1, ix) ' PRINT #hDbg, "numStrClipOff sResult="+sResult
  
    IF INSTR(sNumINPUT,".") = 0 THEN sResult = sResult + "."
  
    count = count + 1
    WHILE count <= precision
      sResult = sResult + "0"
      count = count + 1
    WEND
  
    IF LEN(sNumINPUT) <> ePos THEN sResult = sResult + Substring(sNumINPUT, locE, LEN(sNumINPUT))

  FUNCTION = sResult

END FUNCTION
           

''
FUNCTION numCutOff( NumINPUT AS DOUBLE, precision AS LONG ) AS STRING
                                  
  LOCAL i AS DOUBLE
  LOCAL sOut, sTemp, sResult AS STRING 
                      
    i = NumINPUT
    IF i < 1 THEN i = i + 1
  
    sTemp = FORMAT$(i)
    sTemp = numStrClipOff(sTemp, precision)
  
    IF i = NumINPUT THEN
      sResult = substring(sTemp, 1, 2)
    ELSE
      sResult = "0" 
    END IF
  
    sResult = sResult + substring(sTemp, 2, LEN(sTemp))

  FUNCTION = sResult

END FUNCTION
   

''
FUNCTION Convert2Dec( this AS ieeeTYPE ) AS STRING 
         
  
  LOCAL s, i, dp, hid, temp, power AS LONG ' ?  
  LOCAL Valu, decValue AS DOUBLE
  LOCAL sOut AS STRING


    IF this.fSize = 32 THEN s = 10 ELSE s = 13
  
    IF this.BinaryPower < this.MinExp OR this.BinaryPower > this.MaxExp THEN
      dp   = 0
      Valu = 0
    ELSE
      dp   = - 1
      Valu =   1
    END IF ' PRINT #hDbg, "fSize="+STR$(this.fSize) 

    FOR i = s TO this.fSize
      Valu = Valu + this.Result(i) * 2^(dp+s-i) ' PRINT #hDbg, "i="+STR$(i) + ", Result(i)="+STR$(this.Result(i)) + ", dp+s-i="+STR$(dp+s-i) + ", 2^(dp+s-i)="+STR$(2^(dp+s-i)) + ", Valu="+STR$(Valu) 
    NEXT
    decValue = Valu * 2^this.BinaryPower 'PRINT #hDbg, "decValue="+STR$(decValue) + ", BinaryPower="+STR$(this.BinaryPower) + ", 2^BinaryPower="+STR$(2^this.BinaryPower) + ", Valu="+STR$(Valu) 

  
    IF this.fSize = 32 THEN
      s = 8
      power = FIX( LOG(decValue) / LN10 )
      decValue = decValue + 0.5 * 10^(power-s+1)
    ELSE 
      s = 17   
    END IF
  
    IF this.Result(0) = 1 THEN decValue = -decValue
  
     ' the system refuses to display negative "0"s with a minus sign
    this.DecValue = FORMAT$(decValue)
    IF this.DecValue = "0" AND this.Result(0) = 1 THEN this.DecValue = "-" + this.DecValue
  
    this.DecValue = numStrClipOff( TRIM$(this.DecValue), s )
  
    sOut = numCutOff(Valu, s)
        
  FUNCTION = sOut

END FUNCTION         


''
FUNCTION Compute( Obj AS DisplayTYPE, Rounding AS LONG ) AS LONG

'  in this javascript program, bit positions are numbered 
'  0 ~ 32/64 from left to right instead of right to left, 
'  the way the output is presented
                  
         
  
  LOCAL i, index1, Cnst AS LONG ' ? 
  LOCAL sTemp AS STRING 

  LOCAL ieee32 AS ieeeTYPE
  LOCAL ieee64 AS ieeeTYPE
          
                   
PRINT #hDbg, "InputDec="+Obj.InputDec 
PRINT #hDbg, "" 

    CALL Initieee(32, ieee32) ' Assigne the UDT variables
    CALL Initieee(64, ieee64) ' Assigne the UDT variables
  
           
    Cnst = 2102	'  1 (carry bit) + 1023 + 1 + 1022 + 53 + 2 (round bits)
                              
                                 


' 64bit DOUBLE

    CALL Dec2Bin( ieee64, TRIM$(Obj.InputDec) ) ' PRINT #hDbg, "Dec2Bin="+ieee64.Dec2Bin 

    ieee64.BinString = Convert2Bin( ieee64, 0 ) ' PRINT #hDbg, "BinString64="+ieee64.BinString  

    obj.bin64_0     = substring( TRIM$(ieee64.BinString), 1, 2 )
    obj.bin64_1     = substring( TRIM$(ieee64.BinString), 2, 13 )     

    IF ieee64.BinaryPower < ieee64.MinExp OR ieee64.BinaryPower > ieee64.MaxExp THEN  
      sTemp = " "
      sTemp = sTemp + substring( TRIM$(ieee64.BinString), 13, 14 )
      sTemp = sTemp + "."                                        
      sTemp = sTemp + substring( TRIM$(ieee64.BinString), 14, 64 )
    ELSE                                                         
      sTemp = "1."                                              
      sTemp = sTemp + substring( TRIM$(ieee64.BinString), 14, 64 )
    END IF
                   
    obj.bin64_12  = sTemp 
    obj.stat64    = ieee64.StatCond
    obj.binpwr64  = ieee64.BinaryPower
    obj.binpwr64f = ieee64.BinaryPower + ieee64.ExpBias 
                

    sTemp = ""
    FOR i = 1 TO 64             
      sTemp = sTemp + FORMAT$(ieee64.Result(i))
    NEXT ' PRINT #hDbg, "this.Result=" + sTemp


    obj.dec64sig  = Convert2Dec(ieee64) ' PRINT #hDbg, "dec64sig="+obj.dec64sig 

    IF ieee64.DispStr <> "" then
      obj.dec64    = ieee64.DispStr
      obj.dec64sig = ""
    ELSE
      obj.dec64    = ieee64.DecValue 
    END IF '

    obj.hex64 = Convert2Hex(ieee64)
                   
    FOR index1 = 1 TO Cnst 
      ieee32.BinVal(index1) = ieee64.BinVal(index1) 
    NEXT                                                    
                                    
PRINT #hDbg, FORMATieeeTYPE(ieee64) 
PRINT #hDbg, "--------------------------"

                        



'   32bit SINGLE

    ieee32.BinString = Convert2Bin( ieee32, rounding ) ' PRINT #hDbg, "BinString32="+ieee32.BinString 
    obj.bin32_0 = substring( TRIM$(ieee32.BinString), 1, 2 )
    obj.bin32_1 = substring( TRIM$(ieee32.BinString), 2, 10 )   

    IF ieee32.BinaryPower < ieee32.MinExp OR ieee32.BinaryPower > ieee32.MaxExp THEN
      sTemp = " "
      sTemp = sTemp + substring( TRIM$(ieee32.BinString), 10, 11 )
      sTemp = sTemp + "."        
      sTemp = sTemp + substring( TRIM$(ieee32.BinString), 11, 32 )
    ELSE                         
      sTemp = "1."              
      sTemp = sTemp + substring( TRIM$(ieee32.BinString), 10, 32 )
    END IF   

    obj.bin32_9   = sTemp 
    obj.stat32    = ieee32.StatCond
    obj.binpwr32  = ieee32.BinaryPower
    obj.binpwr32f = ieee32.BinaryPower + ieee32.ExpBias
    obj.dec32sig  = Convert2Dec(ieee32)
    IF ieee32.DispStr <> "" THEN                                                                                            
      obj.dec32    = ieee32.DispStr                                                              
      obj.dec32sig = ""                                                                                                                                                                     
    ELSE                                                                                            
      obj.dec32    = ieee32.DecValue 
    END IF   
                                                            
    obj.hex32 = Convert2Hex(ieee32) 
                                                      
                                                                                                    
    IF ieee64.DispStr <> "" AND ieee32.DispStr <> "" THEN                                           
      obj.entered  = VAL(ieee64.DispStr)                                                            
    ELSE                                                                                            
      obj.entered  = VAL(Obj.InputDec) 
    END IF '
PRINT #hDbg, FORMATieeeTYPE(ieee32)  
PRINT #hDbg, "--------------------------"                                                             
                                                                                                    
END FUNCTION                                                                                        
                                                                                                    


'
FUNCTION PBMAIN 
               
  LOCAL i, Rounding AS LONG
  LOCAL d AS DOUBLE  
  LOCAL s AS SINGLE   

  LOCAL Obj AS DisplayTYPE 


               
  hDbg = FREEFILE ' 
  OPEN "FloatDebug.txt" FOR OUTPUT LOCK WRITE AS hDbg ' PRINT #hDbg, "MetersToFt="+STR$(MetersToFt) 
   
  Obj.InputDec = "523.34"    
'  Obj.InputDec = "118.625"               
  CALL Compute( Obj, 0 ) ' Rounding = 0

PRINT #hDbg, FORMATDisplayTYPE(Obj) 
                   
MSGBOX "All Done"  : EXIT FUNCTION


  CLOSE hDbg 

END FUNCTION 


''


